##-----------------------------LICENSE NOTICE------------------------------------
##  This file is part of CPCtelera: An Amstrad CPC Game Engine 
##  Copyright (C) 2018 ronaldo / Fremos / Cheesetea / ByteRealms (@FranGallegoBR)
##
##  This program is free software: you can redistribute it and/or modify
##  it under the terms of the GNU Lesser General Public License as published by
##  the Free Software Foundation, either version 3 of the License, or
##  (at your option) any later version.
##
##  This program is distributed in the hope that it will be useful,
##  but WITHOUT ANY WARRANTY; without even the implied warranty of
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU Lesser General Public License for more details.
##
##  You should have received a copy of the GNU Lesser General Public License
##  along with this program.  If not, see <http://www.gnu.org/licenses/>.
##------------------------------------------------------------------------------
############################################################################
##                        CPCTELERA ENGINE                                ##
##                 Automatic image conversion file                        ##
##------------------------------------------------------------------------##
## This file is intended for users to automate image conversion from JPG, ##
## PNG, GIF, etc. into C-arrays.                                          ##
############################################################################

##
## NEW MACROS
##

## 16 colours palette
#PALETTE=0 1 2 3 6 9 11 12 13 15 16 18 20 24 25 26

## Default values
#$(eval $(call IMG2SP, SET_MODE        , 0                  ))  { 0, 1, 2 }
#$(eval $(call IMG2SP, SET_MASK        , none               ))  { interlaced, none }
#$(eval $(call IMG2SP, SET_FOLDER      , src/               ))
#$(eval $(call IMG2SP, SET_EXTRAPAR    ,                    ))
#$(eval $(call IMG2SP, SET_IMG_FORMAT  , sprites            ))	{ sprites, zgtiles, screen }
#$(eval $(call IMG2SP, SET_OUTPUT      , c                  ))  { bin, c }
#$(eval $(call IMG2SP, SET_PALETTE_FW  , $(PALETTE)         ))
#$(eval $(call IMG2SP, CONVERT_PALETTE , $(PALETTE), g_palette ))
#$(eval $(call IMG2SP, CONVERT         , img.png , w, h, array, palette, tileset))

## 16 colours palette
PALETTE=3 1 2 0 6 9 11 12 13 15 16 18 20 24 25 26

$(eval $(call IMG2SP, SET_MODE        , 0                  ))
$(eval $(call IMG2SP, SET_FOLDER      , src/sprites))
$(eval $(call IMG2SP, SET_PALETTE_FW  , $(PALETTE)))
$(eval $(call IMG2SP, CONVERT_PALETTE , $(PALETTE), g_palette ))

#$SPRITES JUEGO
$(eval $(call IMG2SP, CONVERT         , img/Player.png , 16, 26, sp_player))
$(eval $(call IMG2SP, CONVERT         , img/arma.png , 12, 10, sp_arma))
$(eval $(call IMG2SP, CONVERT         , img/background.png , 80, 27, sp_background))
$(eval $(call IMG2SP, CONVERT         , img/Lava.png , 18, 26, sp_lava))
$(eval $(call IMG2SP, CONVERT         , img/Fireball.png , 12, 2, sp_fireball))
$(eval $(call IMG2SP, CONVERT         , img/Mago.png , 14, 30, sp_wizard))
$(eval $(call IMG2SP, CONVERT         , img/Piedra.png , 4, 12, sp_piedra))
$(eval $(call IMG2SP, CONVERT         , img/EndDoor.png , 16, 40, sp_end_door))
$(eval $(call IMG2SP, CONVERT         , img/Vida1.png , 48, 24, sp_live1))
$(eval $(call IMG2SP, CONVERT         , img/Vida2.png , 48, 24, sp_live2))
$(eval $(call IMG2SP, CONVERT         , img/Vida3.png , 48, 24, sp_live3))

#$IMAGENES MENU
$(eval $(call IMG2SP, SET_FOLDER, src/menu))
$(eval $(call IMG2SP, SET_IMG_FORMAT, screen))
$(eval $(call IMG2SP, SET_OUTPUT, bin))
$(eval $(call IMG2SP, CONVERT, img/Menu.png, 0, 0, menu))

$(eval $(call IMG2SP, CONVERT, img/Controls.png, 0, 0, menu))

$(eval $(call IMG2SP, CONVERT, img/Credits.png, 0, 0, menu))

$(eval $(call IMG2SP, CONVERT, img/Death.png, 0, 0, menu))

$(eval $(call IMG2SP, CONVERT, img/Win.png, 0, 0, menu))


#$(eval $(call IMG2SP, CONVERT, img/Controls.png, 0, 0, menu))

#$(eval $(call IMG2SP, CONVERT, img/Creditos.png, 0, 0, menu))

