.module entities
.include "man/entities_public.s"
.include "cpctelera.h.s"

.globl cpct_memset_asm
.globl cpct_memcpy_asm
.globl cpct_getRandom_xsp40_u8_asm


;;
;; ENTITIES. This is where the entity data will be stored
;;

.db 0xBE, 0xEF, 0xBE, 0xEF, 0xBE, 0xEF, 0xBE, 0xEF, 0xBE, 0xEF, 0xBE, 0xEF


;;
;; ENTITIES ARRAY. This is where the entities array will be stored
;;
entities_array::
   .ds TOTAL_BYTES_ENTITIES
;;

.db 0xBE, 0xEF, 0xBE, 0xEF, 0xBE, 0xEF, 0xBE, 0xEF, 0xBE, 0xEF, 0xBE, 0xEF

;;
;; NUM ENTITIES. This is where the number of entities will be stored
;;
num_entities::
   .db 0
;;

;;
;; FLIP. This is where the number of flip be stored
;;
flip::
   .db 0
;;
.db 0xBE, 0xEF

espacio::
   .db 1
;;
.db 0xBE, 0xEF

;;
;; FIREBALL. This is where the number of flip be stored
;;
fireball::
   .db 1
;;
.db 0xBE, 0xEF

;;
;; RATIO FIREBALL. This is where the number of flip be stored
;;
ratiofireball::
   .db 175
;;
.db 0xBE, 0xEF

;;
;; FLIP ARM. This is where the number of flip be stored
;;
flip_arma::
   .db 0
;;
.db 0xBE, 0xEF

;;
;; ARM. This is where the number of flip be stored
;;
arma::
   .db 0
;;
.db 0xBE, 0xEF

jumping::
   .db 0
;;
.db 0xBE, 0xEF


;;
;; WEAPON ADRESS. This is where the adress for the weapon will be stored
;;
weapon_adress::
   .dw 0
;;
.db 0xBE, 0xEF

player_health_max = 5
player_health::
   .db #player_health_max
;;

;;
;; PLAYER ADRESS. This is where the adress for the player will be stored
;;
player_adress::
   .dw 0
;;
.db 0xBE, 0xEF
player_invencible::
   .db #0
;;
.db 0xBE, 0xEF
player_invencible_time_max= 20

player_invencible_time::
   .db #player_invencible_time_max
;;
.db 0xBE, 0xEF

piedras::
   .db 3
;;
.db 0xBE, 0xEF


lives::
   .db 3
;;
.db 0xBE, 0xEF

live_adress::
   .dw 0
;;
.db 0xBE, 0xEF

;;
;; NEXT FREE ENTITY. This is where the adress for the next free entity location will be stored
;;
next_free_entity:
   .dw 0
;;
.db 0xBE, 0xEF


;;
;; VX NEXT ENTITY. This is where the value for the next entity's vx will be stored
;;
vx_next_entity:
    .db 1
.db 0xBE, 0xEF
;;
;; ENTITIES INIT function. This sets the entities array, and "next_free_entity" adress value
;; DESTROYED REGISTERS: [AF, BC, DE, HL]
;;
man_entities_init::
    ld de, #entities_array
    xor a ;; a = 0
    ld bc, #TOTAL_BYTES_ENTITIES
    call cpct_memset_asm
    ld hl, #entities_array
    ld (next_free_entity), hl
    xor a ;; a = 0

    ld (num_entities), a

    ld hl, #0
    ld (weapon_adress), hl
    ld (player_adress), hl

   ret
;;

;;
;; GET NEXT ENTITY function. This returns in HL the address for the following entity
;; INPUTS
;; - HL: Address for an entity
;; OUTPUTS
;; - HL: Address for the next entity (the first one if it's the last one)
;;
man_entities_get_next::
    ld bc, #BYTES_PER_ENTITY
    add hl, bc

    ret
;;
   
;;
;; CREATE MOTHERSHIP function. This creates a new mothership with "_mothership_templ" values in the "next_free_entity" location
;; INPUTS
;; - DE: Address where the entity will be created 
;; - HL: Template for the entity will be created
;;
man_entities_create::
    push de
    pop ix

    ;;if que dependa de valor a que se pase en game.s
    ;; PLANTILLA ENTIDAD YA ESTA EN HL
    ;;ld hl, #_mothership_templ
    ld bc, #BYTES_PER_ENTITY
    ldir


    ;; Increment number of entities
    ld a, (num_entities)
    inc a
    ld (num_entities), a


    ;; Increment number of next free entity
    ld hl, #BYTES_PER_ENTITY
    ld de, (next_free_entity)
    add hl, de
    ld (next_free_entity), hl


    ret
;;
   
;;
;; CREATE ENTITY BY INDEX function. This creates a new entity in the address of the input index
;; INPUTS
;; - A: Index of the to-be created entity 
;; - HL: Template for the entity will be created
man_entities_create_by_index::
    push hl

    ld b, #BYTES_PER_ENTITY

    or a
    jr z, _bypass_loop_multiply

    

    ld hl, #0
    ld d, #0
    ld e, a

    ;; Obtener resultado en HL (overflow en 8 bit)
    _loop_multiply:
        add hl, de
        dec b
        jr nz, _loop_multiply

    ex de, hl
    jr _end_loop_multiply
    

    _bypass_loop_multiply:
        ld de, #0

    _end_loop_multiply:
        ld hl, #entities_array
        add hl, de
        ex de, hl

    pop hl

    call man_entities_create

    ret
;;
   
;;
;; CREATE ENTITY IF SPACE function. This creates a new entity if the array isn't complete
;; INPUTS
;; - HL: Template for the entity will be created
man_entities_create_if_space::
    ld a, (num_entities)
    cp #MAX_ENTITIES
    ret nc

    call man_entities_create_by_index

    ret
;;



;;
;; CREATE PLAYERSHIP
;;
man_entity_create_player::
    ;; CARGA PLANTILLA DE PLAYERS
    ld hl, #_player_templ

    call man_entity_get_next_free_entity
    ld__e_ixl
    ld__d_ixh
    
    ld (player_adress), de

    call man_entities_create_if_space
    ret
;;


;;
;; CREATE LAVA
;;
man_entity_create_lava::
    ld hl, #_lava_templ

    call man_entities_create_if_space
    ret
;;


;;
;; CREATE LAVA LEFT
;;
man_entity_create_lava_left::
    ld hl, #_lava_templ

    call man_entities_create_if_space

    ld _x_e(ix), #0
    ret
;;

;;
;; CREATE PIEDRA
;;
man_entity_create_piedra::
    ld hl, #_piedra_templ

    call man_entities_create_if_space
    ret
;;

;;
;; CREATE FIREBALL
;;
man_entity_create_fireball::
    ld hl, #_fireball_templ

    call man_entities_create_if_space
    ret
;;

;;
;; CREATE Wizard
;;
man_entity_create_wizard::
    ld hl, #_wizard_templ

    call man_entities_create_if_space
    ret
;;


;;
;; CREATE LIVEPLAYER
;;
man_entity_create_liveplayer::
    ld hl, #_liveplayer_templ

    call man_entities_create_if_space
    ret
;;

;;
;; CREATE ARMA
;;
man_entity_create_weapon::
    ld hl, #_weapon_templ

    call man_entities_create_if_space
    ret
;;

;;
;; ENTITY GET NEXT FREE ENTIY function. This gets the adress of the next entity free space in the array
;; INPUTS
;; - IX: Address of the entity to be set 
;;
man_entity_get_next_free_entity::
    ld ix, (next_free_entity)
    
    ret
;;

   
;;
;; ENTITY SET FOR DESTRUCTION function. This sets an entity type's to dead (_type_e = e_type_dead)
;; INPUTS
;; - IX: Address of the entity to be set to "dead" 
;;
man_entities_set4destruction::
    ld a, _type_e(ix)
    or #e_type_dead
    ld _type_e(ix), a

    call sys_render_background_color_box
    ret
;;


man_entities_set4destruction_weapon::
    ld a, _type_e(ix)
    or #e_type_dead
    ld _type_e(ix), a

    ;call sys_render_background_color_box
    ret
;;
   
;;
;; ENTITIES DESTROY function. This destroys an entity
;; INPUTS
;; - IX: Address of the entity to be set to "dead"
;;
man_entities_destroy::
    ;; Decrement number of entities
    ld a, (num_entities)
    dec a
    ld (num_entities), a


    ld hl, (next_free_entity)
    ld bc, #-BYTES_PER_ENTITY
    add hl, bc
    ld (next_free_entity), hl
    ld__a_ixl
    sub l
    jr nz, _copy
    ld__a_ixh
    sub h
    jr z, _nocopy

    _copy:
        ld (weapon_adress), ix
        ld__e_ixl
        ld__d_ixh
        ld bc, #BYTES_PER_ENTITY
        ldir
    _nocopy:
        ld hl, (next_free_entity)
        ld (hl), #0

        ret
;;

;;
;; ENTITIES UPDATE function. This checks for every entity (until finding e_type_invalid)
;;  If the type is e_type_dead, it calls for the entity destruction. Else, continue.
;;
man_entities_update::
    ld ix, #entities_array
    jr _next_e

    _destroy_e:
        call man_entities_destroy
    _next_e:
        ld a, _type_e(ix)
        or a
        ret z
        and #e_type_dead
        jr nz, _destroy_e
    _dont_delete_e:
        ld bc, #BYTES_PER_ENTITY
        add ix, bc
        jr _next_e


;;
;; FOR ALL ENTITIES function. This calls a function for each and every entity of the array
;; INPUTS
;; - HL: Address of the function to be called 
;;
man_entities_forall::
    ld (_to_call), hl           ;; Set function to be called
    ld ix, #entities_array      ;; IX points to first entity in array

    _next_entity:
        ld a, (ix)
        or a                     ;; Compare A to 0
        ret z                    ;; If A = 0 (e_type_invalid) ends the loop
    _to_call = .+1
        call _to_call               ;; Calls set function
        ld bc, #BYTES_PER_ENTITY
        add ix, bc                  ;; Moves to next entity
        jr _next_entity
;;

;;
;; FOR ALL ENTITIES MATCHING function. This calls a function for each and every entity of the array that has a type that matches the input
;; INPUTS
;; - HL: Address of the function to be called 
;; - B: Entity type to be matched 
;;
man_entities_forall_matching::
    ld a, (num_entities)
    cp #0 
    jr z, noEntities

    ld ix, #entities_array 
    ld (_matching_to_call), hl

    bucle:
        ld c, a

        ;;comprobamos si la entidad es valida o no
        ld a, _type_e(ix) 
        cp #e_type_invalid
        jr z, noEntities

        push bc
        
        ;; Comprobar que el estado de la entidad coincide con la mascara que pasan por el registro B
        ld a, _type_e(ix)  
        and b
        cp b
        jr nz, no_matching
            push bc
            _matching_to_call = .+1
            call _matching_to_call  ;; Calls set function
            pop bc
        no_matching:

        pop bc
        ld a, c
        ld de, #BYTES_PER_ENTITY
        add ix, de ;;paso a la siguiente

        dec a
        jp nz, bucle

    noEntities:
ret


man_entities_set_invencible::
    ld a, #1 
    ld (player_invencible), a
    ld a, #player_invencible_time_max
    ld (player_invencible_time), a
ret
;;

man_entities_unset_invencible::
    xor a
    ld (player_invencible), a
ret
;;

man_entities_update_health::
    ld a, (player_health)
    dec a
    ld (player_health), a
    ret nz

    _decrease_live:
    call man_game_destroy_live
    ld a, (lives)
    cp a, #0
    call z, man_game_level_finish
    call nz, man_game_level_reset
    
    ld a, #player_health_max
    ld (player_health), a

ret
;;

man_entities_reset_health::
    ld a, #player_health_max 
    ld (player_health), a

ret
;;

man_entities_reset_player_height::
   ld ix, #player_adress
   ld a, #148
   ld _x_e(ix), a

    

ret
;;