.module game
.include "cpctelera.h.s"
.include "entities_public.s"
.include "man/levels_public.s"


.globl cpct_disableFirmware_asm
.globl cpct_setDrawCharM0_asm
.globl cpct_drawCharM0_asm
.globl cpct_waitVSYNC_asm
.globl cpct_getRandom_xsp40_u8_asm
.globl sys_time_init
.globl sys_render_init
.globl sys_score_init
.globl man_entities_init
.globl man_levels_init
.globl sys_time_update
.globl sys_physics_update
.globl man_entities_update
.globl sys_render_update
.globl sys_ai_update
.globl cpct_akp_musicPlay_asm
.globl cpct_akp_stop_asm
.globl man_entities_set4destruction
.globl man_levels_get_current_level
.globl player_health



minimum_play_x_spawn_left = 20
maximum_play_x_spawn_right = 50

;;
;; GAME PLAY INIT function. This is called to start the game play section of the game.
;;
man_game_play_init:
   call man_levels_reset_pattern_step
   
   ld a, (current_level)
   or a
   jr nz, _no_inicio_partida

   inc a
   ld (current_level), a

   inc a
   inc a
   ld (lives), a

   call sys_score_init

   _no_inicio_partida:
      call man_levels_get_current_level
      ld__a_ixl
      ld__iyl_a
      ld__a_ixh
      ld__iyh_a
      call sys_time_level_init

      call man_entities_init

      call man_entity_create_player

      call man_levels_get_current_level
      
      ld a, _wizard_spawn_l(ix)
      or a
      call nz, man_entity_create_wizard
      
      call sys_render_background

   ret
;;

;;
;; GAME INIT function. 
;;
man_game_init::
   call sys_render_init
   call music_init
   call sys_score_init
   call man_levels_init

   menu:
       ;;INICIO DEL MENU
       call menu_init
       
        _loop_menu:
         
       call cpct_waitVSYNC_asm
       call cpct_akp_musicPlay_asm  

        ;;INPUT Y CARGA PANTALLA MENU
        call menu_update

        ;;EMPEZAR
        ld a, (salir_menu)
        dec a
        jr z, game_start

   jr _loop_menu

   game_start:
   call cpct_akp_stop_asm

   ;;INICIA JUEGO
   call man_game_play_init

   ret
;;

;;
;; GAME PLAY function. 
;;
man_game_play::
   call sys_render_background
   call music_init_combate
   game_loop:

      ld a, (create_enemy_timer)
      or a

      jr nz, _create_enemy_timer_not_0
      ;;LLAMAR A CREACION ENEMIGO
      call man_game_create_enemy


      _create_enemy_timer_not_0:
         call cpct_waitVSYNC_asm
         call cpct_akp_musicPlay_asm  

         call man_levels_get_current_level

         ;; IX to IY
         ld__a_ixl
         ld__iyl_a
         ld__a_ixh
         ld__iyh_a

         call sys_time_update
         call sys_ai_update
         call man_game_check_invencible


         call sys_collision_player_update
         call sys_collision_weapon_update
         call sys_physics_update

         call sys_render_update
         call man_entities_update

         call man_game_check_level_finish
         
         call cpct_waitVSYNC_asm
         call cpct_waitVSYNC_asm      
      
         jr game_loop
   ret
;;

man_game_create_weapon::
   ld b, _x_e(ix)
   ld c, _y_e(ix)

   push bc

   ;; Create new enemy
   call man_entity_get_next_free_entity
   ld__e_ixl
   ld__d_ixh
   
   ld (weapon_adress), de

   call man_entity_create_weapon


   pop bc

   ;; Comprobar si variable flip 1(mira a la izquierda)
    ld a, (flip)
    cp a, #1
    jr nz, dere

    ld a, (flip_arma) ;; 1 es que ta esta girado el sprite arma
    cp a, #1
    jr z, derechita

    push bc
    ;; Girar el sprite
    ld de, #_sp_arma
    ld h, _h_e(ix)
    ld l, _w_e(ix)
    call cpct_hflipSpriteM0_r_asm
    pop bc

    ld a, #1         ;;poner que no haga mas flip
    ld (flip_arma), a

    derechita:

    ld a, b
    sub a, #4
    ld _x_e(ix), a

    ld a, c
    add a, #10
    ld _y_e(ix), a

    jr _end_create_weapon

   dere:
   ld a, b
   add a, #6
   ld _x_e(ix), a

   ld a, c
   add a, #10
   ld _y_e(ix), a

   ld a, (flip_arma) ;; 0 es que no girado el sprite arma
    cp a, #0
    jr z, _end_create_weapon

    push bc
    ;; Girar el sprite
    ld de, #_sp_arma
    ld h, _h_e(ix)
    ld l, _w_e(ix)
    call cpct_hflipSpriteM0_r_asm
    pop bc

    ld a, #0         ;;poner que no haga mas flip
    ld (flip_arma), a



   
   _end_create_weapon:


   ret
;;

man_game_create_enemy::
   call man_levels_get_current_level

   ld a, _pattern_l(ix)
   cp #1
   jp z, _pattern_1
   cp #2
   jp z, _pattern_2
   cp #3
   jp z, _pattern_3
   cp #4
   jp z, _pattern_4
   cp #5
   jp z, _pattern_5

   ret

   _pattern_1: 
      call man_game_create_fireball_right

      jr _end_man_game_create_enemy

   _pattern_2:
      ld a, (pattern_step)
      cp #2
      push af
      call nz, man_game_create_fireball_right
      pop af
      call z, man_entity_create_lava

      jr _end_man_game_create_enemy

   _pattern_3: 
      ld a, (pattern_step)
      or a
      push af
      call z, man_game_create_fireball_left
      pop af
      call nz, man_game_create_fireball_right

      jr _end_man_game_create_enemy

   _pattern_4: 
      call man_entity_create_lava

      jr _end_man_game_create_enemy

   _pattern_5: 
      ld a, (pattern_step)
      or a
      push af
      call z, man_game_create_fireball_left
      pop af
      call nz, man_entity_create_lava

      jr _end_man_game_create_enemy
      
   _end_man_game_create_enemy:
      call man_levels_get_current_level
      call man_levels_update_pattern_step
      ret
;;

man_game_create_fireball_left:
   call man_entity_create_fireball

   ret
;;

man_game_create_fireball_right:
   call man_entity_create_fireball
   ld a, #-2
   ld _vx_e(ix), a

   ld a, #74
   ld _x_e(ix), a

ret
;;

man_game_create_piedra::
   ;; CAN CREATE
   ld a, (piedras)
   cp a, #0
   jr z, _occupied_lane



   ld b, _y_e(ix)
   ld c, _x_e(ix)

   push bc

   ;; Create new enemy
   call man_entity_create_piedra

   pop bc

   ld a, b
   add a, #4
   ld _y_e(ix), a

   ld _x_e(ix), c


   ;; Mark piedra on
   ld a, (piedras)
   dec a
   ld (piedras), a



   _occupied_lane:
   
ret
;;

man_game_destroy_live::
   ld a, (lives)
   dec a
   ld (lives), a

   ;;2 VIDAS
   cp a, #2
   jr nz, _one_live
   ret

   _one_live:
   ;;1 VIDAS
   cp a, #1
   jr nz, _zero_live
   ret

   _zero_live:
   call man_levels_reset_pattern_step
   ld (current_level), a
   inc a
   ld (lose), a
   call music_init_muerte
   call menu

ret
;;


man_game_check_invencible::
   ld a, (player_invencible)
   or a
   ret z

   ld a, (player_invencible_time)
   dec a
   or a
   call z, man_entities_unset_invencible 
   ld (player_invencible_time), a

ret
;;


;;
;; GAME CHECK LEVEL FINISH function. This checks if the player has reached the end of the level
;; [UNDER CONSTRUCTION]
;; DESTROYED REGISTERS: [AF, BC, DE, HL]
;;
man_game_check_level_finish:
   ld ix, (player_adress)

   ld a, _x_e(ix)
   cp #62 ;; (Door X - Player width = 70-8)
   call nc, man_game_level_finish
   
   ret
;;


;;
;; GAME LEVEL FINISH function. This makes sure the level ends and continues to the next one (until the last one)
;; [UNDER CONSTRUCTION]
;; DESTROYED REGISTERS: [ALL (?)]
;;
man_game_level_finish::
   ld  hl, #man_entities_set4destruction
   call man_entities_forall

   ld a, (player_health)
   or a
   call nz, sys_score_add_timer

   ld   a, (current_level)
   cp   #NUM_LEVELS
   jr   z, _level_finish_final_level

   inc  a
   ld   (current_level), a
   call man_game_play_init

   ret

   _level_finish_final_level:
      call man_entities_reset_health
      
      call man_levels_reset_pattern_step
      ld (current_level), a

      ld a, (win)
      inc a
      ld (win), a
      call menu
   
      ret
;;

man_game_level_reset::
   ld   a, (current_level)
   dec  a
   ld   (current_level), a

   call man_game_level_finish

   ret
;;