.include "cpctelera.h.s"

.globl music_init

pulsado:: .db 0
salir_menu:: .db 0
pantalla_menu:: .db 1
lose:: .db 0
win:: .db 0

keyboard_menu::
    ld a, #0
    ld (pulsado), a

    call cpct_scanKeyboard_f_asm
    ld hl, #Key_1
    call cpct_isKeyPressed_asm
    jr z, not_press_1 

    press_1:
        ld a, #1
        ld (pulsado), a
        ret
    not_press_1:

    call cpct_scanKeyboard_f_asm
    ld hl, #Key_2
    call cpct_isKeyPressed_asm
    jr z, not_press_2 

    press_2:
        ld a, #2
        ld (pulsado), a
        ret
    not_press_2:

    call cpct_scanKeyboard_f_asm
    ld hl, #Key_3
    call cpct_isKeyPressed_asm
    jr z, not_press_3

    press_3:
        ld a, #3
        ld (pulsado), a
        ret
    not_press_3:

    call cpct_scanKeyboard_f_asm
    ld hl, #Key_B
    call cpct_isKeyPressed_asm
    jr z, not_press_b

    press_b:
        ld a, #4
        ld (pulsado), a
        ret
    not_press_b:
ret
;;

carga_pantalla_win::
    call reset
    ld de, #0xFFFF
    ld hl, #_win_end
    call cpct_zx7b_decrunch_s_asm

    call sys_render_set_black_char_background

    call sys_render_final_score

    call sys_render_set_red_char_background
ret
;;

carga_pantalla_controles::
    ld a, #5
    ld (pantalla_menu),a
    call reset
    ld de, #0xFFFF
    ld hl, #_controls_end

    call cpct_zx7b_decrunch_s_asm

ret
;;

carga_pantalla_creditos::
    ld a, #6
    ld (pantalla_menu),a
    call reset
    ld de, #0xFFFF
    ld hl, #_credits_end

    call cpct_zx7b_decrunch_s_asm

ret
;;



menu_update::
    call keyboard_menu  

    ld a, (pulsado)  
    or a
    ret z

    pantallas_arriba_abajo:
    ld a,(pulsado)
    dec a 
    jr z, comenzar
    dec a
    jr z, controles_
    dec a
    jr z, creditos_
    dec a 
    jr z, volver_menu
    ret

    comenzar:
    ld a, #1
    ld (salir_menu), a
    call reset
    ret
    controles_:
    call carga_pantalla_controles
    ret
    creditos_:
    call carga_pantalla_creditos
    ret
    volver_menu:
    call menu_init
    ret
ret


carga_pantalla_death::
    call reset
    ld de, #0xFFFF
    ld hl, #_death_end
    call cpct_zx7b_decrunch_s_asm

ret
;;

menu_init::
    ld a, #0
    ld (salir_menu), a
    inc a
    ld (pantalla_menu),a
    call reset
    ld de, #0xFFFF
    ld a, (win)
    or a
    jr nz, no_menu_win
    ld a, (lose)
    or a
    jr z, no_menu
    ld hl, #_death_end


    jr avanza

    no_menu:
    push de 
    push hl
    push ix
    push af
    call music_init 
    pop af 
    pop ix
    pop hl
    pop de
    ld hl, #_menu_end
    jr avanza

    avanza:
    ld a, #0
    ld (lose), a
    ld (win), a
    call cpct_zx7b_decrunch_s_asm

    ret

    no_menu_win:
    ld a, #0
    ld (lose), a
    ld (win), a
    call carga_pantalla_win

    ret
;;

;;; BORRADO DE LA PANTALLA
reset::
    ;;borro pantalla
  ld de, #0xC000
  ld  a, #0x00
  ld  c, #40
  ld  b, #200

  call cpct_drawSolidBox_asm

  ld de, #0xC028
  ld  a, #0x00
  ld  c, #40
  ld  b, #200

  call cpct_drawSolidBox_asm

   cpctm_setBorder_asm HW_BLACK

ret