.module ai

.include "cpctelera.h.s"
.include "man/entities_public.s"

.globl man_entities_forall_matching


;;
;; AI CHECK KEYBOARD function. This updates the _vx_e value depending on keyboard inputs
;; Only called for entities with type "e_type_input"
;; INPUTS
;; - IX: Adress for the entity
;;
sys_ai_check_keyboard::
    ;ld a, _vx_e(ix)
    ;cp a, #0
    ;jr nz, _attack_Keyboard ;;COMENTANDO ESTO SALTO PLANEANDO


    ;; ¿ARMA CREADA?
    ld a, (arma)
    or a
    jr nz, _attack_Keyboard

    ;; ¿SALTO?
    ld a, (jumping)
    cp a, #1
    jr z, _jumping_activated ;Sí

    call  cpct_scanKeyboard_asm  ;NO
    ld    hl, #Key_Q
    call  cpct_isKeyPressed_asm
    jr    z, _attack_Keyboard

    ld a, #-2
    ld _vy_e(ix), a
    
    ;;TP SALTO
    call sys_render_background_color_box
    ld a, #122
    ld _y_e(ix), a

    ld a, #0
    ld _vx_e(ix), a  ;;DESCOMENTANDO ESTO SALTO PLANEANDO

    ld a, #1
    ld (jumping), a

    _jumping_activated:

     jr  _ent_moveKeyboard ;;DESCOMENTANDO ESTO SALTO PLANEANDO
    ret

    _attack_Keyboard:
        ;; ¿ARMA CREADA?
        ld a, (arma)
        or a
        jr z, _not_created_weapon

        ;;SÌ ¿PULSANDO ESPACIO?
        call  cpct_scanKeyboard_asm
        ld    hl, #Key_Space
        call  cpct_isKeyPressed_asm
        jr    nz, ninguna_pulsada_arma ;;¿PULSANDO ESPACIO? SI, SALTA A NADA

        ;;¿PULSANDO ESPACIO? NO 
        push ix
        ld ix, (weapon_adress)
        call man_entities_set4destruction
        pop ix

        xor a        ;;ld a, #0
        ld (arma), a

        jr _ent_moveKeyboard ;; SALTA A MOVIMIENTO A/D

        _not_created_weapon:
        ;; ¿ARMA CREADA? NO
        call  cpct_scanKeyboard_asm
        ld    hl, #Key_Space
        call  cpct_isKeyPressed_asm
        jr    z, _ent_moveKeyboard ;;¿PULSANDO ESPACIO? NO, SALTA A MOVIMIENTO A/D

        ; CREAR ARMA
        call man_game_create_weapon

        ld a, #1
        ld (arma), a

        jr ninguna_pulsada




    _ent_moveKeyboard:
    call  cpct_scanKeyboard_asm
    ld    hl, #Key_O
    call  cpct_isKeyPressed_asm
    jr    z, a_no_pulsada

    call colision_izquierda  

    ;; Comprobar si variable flipp
    ld a, (flip)
    cp a, #0
    jr nz, cambio

    ;; Girar el sprite
    ld de, #_sp_player
    ld h, _h_e(ix)
    ld l, _w_e(ix)
    call cpct_hflipSpriteM0_r_asm

    ld a, #1
    ld (flip), a


    cambio:
    ret

    a_no_pulsada:
    ld    hl, #Key_P
    call  cpct_isKeyPressed_asm
    jr    z, ninguna_pulsada

    call colision_derecha 

    ;; Comprobar si variable flip
    ld a, (flip)
    cp a, #1
    jr nz, cambioder

    ;; Girar el sprite
    ld de, #_sp_player
    ld h, _h_e(ix)
    ld l, _w_e(ix)
    call cpct_hflipSpriteM0_r_asm

    ld a, #0
    ld (flip), a
    ;call sys_render_background_color_box

    

    cambioder:

    ret

    ninguna_pulsada_arma:
    push ix
    ld ix, (weapon_adress)
    call man_entities_set4destruction
    pop ix

    xor a        ;;ld a, #0
    ld (arma), a


   ld _vx_e(ix), #0
   ld _vy_e(ix), #0
   
   ret

   ninguna_pulsada:
    ld _vy_e(ix), #0
    ld _vx_e(ix), #0

   
   ret

;;

sys_ai_update_one_entity::
    ld l, _behaviour_e(ix) 
    ld h, _behaviour_e+1(ix) 
    
    ld (_behaviour_to_call), hl

    _behaviour_to_call = .+1
    call _behaviour_to_call  ;; Calls set function
ret
;;


sys_ai_behaviour_left_right::
    ;;Valid positions: 0 to 80-width

    ld _y_e(ix), #146
    
    _calcular_nueva_x:
    ld a, _x_e(ix) 

    or a                        ;; Check if A (_x_e) == 0
    jr nz, _not_lower_bound   
    ld _vx_e(ix), #1            ;; If true, set _vx_e = 1

    call man_entities_set4destruction

    ret

    _not_lower_bound:
    ld b, a                     ;; Load A (_x_e) into B
    ld a, #80
    sub _w_e(ix)                ;; A = 80 - sprite width
    cp b                        ;; Check if B (_x_e) == A 
    ret nz

    ld _vx_e(ix), #-1           ;; If true, set _vx_e = -1

  
ret
;;

sys_ai_behaviour_wizard::
    call sys_ai_behaviour_left_right_wizard

    ;;CREAR PIEDRAS
    ld a, _x_e(ix)
    cp #50
    call z, man_game_create_piedra

    ld a, _x_e(ix)
    cp #20
    call z, man_game_create_piedra


ret
;;


sys_ai_behaviour_left_right_wizard::
    ;;Valid positions: 0 to 80-width
    
    _calcular_nueva_xo:
    ld a, _x_e(ix) 

    or a                        ;; Check if A (_x_e) == 0
    jr nz, _not_lower_boundo  
    ld _vx_e(ix), #1            ;; If true, set _vx_e = 1

    ld de, #_sp_wizard
    ld h, _h_e(ix)
    ld l, _w_e(ix)
    call cpct_hflipSpriteM0_r_asm

    ret

    _not_lower_boundo:
    ld b, a                     ;; Load A (_x_e) into B
    ld a, #80
    sub _w_e(ix)                ;; A = 80 - sprite width
    cp b                        ;; Check if B (_x_e) == A 
    ret nz

    ld _vx_e(ix), #-1           ;; If true, set _vx_e = -1
    
    ld de, #_sp_wizard
    ld h, _h_e(ix)
    ld l, _w_e(ix)
    call cpct_hflipSpriteM0_r_asm
ret
;;


sys_ai_behaviour_fireball::

    ;;Va a la derecha
    ld a, _vx_e(ix)
    cp a, #2
    jr nz, no_derecha

    ld a, _x_e(ix)
    cp a, #64
    jr nz, no_destruir

    call man_entities_set4destruction

    no_derecha:
    ld a, _x_e(ix)
    cp a, #2
    jr nz, no_destruir

    call man_entities_set4destruction

    no_destruir:
ret
;;

sys_ai_behaviour_piedra::

    ld a, _y_e(ix)
    cp a, #160
    jr nz, no_destruiro

    call man_entities_set4destruction

    ld a, (piedras)
   inc a
   ld (piedras), a

    no_destruiro:
ret
;;

sys_ai_update::
    ld  hl, #sys_ai_update_one_entity
    ld   b, #e_type_movable | e_type_ai
    call man_entities_forall_matching
ret
;;