.module collision

.include "cpctelera.h.s"
.include "man/entities_public.s"

;;;Player Collision
colision_izquierda::
	ld a, _x_e(ix)
	cp a, #1  
    jr c, si_col_izq
	jr no_col_izq
	ret

si_col_izq::
    ld _vx_e(ix), #0
    ld _vy_e(ix), #0
	ret

no_col_izq::
	ld _vx_e(ix), #-1
    ld _vy_e(ix), #0
	ret


colision_derecha::
	ld a, _x_e(ix)
	cp a, #72
    jr nc, si_col_der
	jr no_col_der
	ret

si_col_der::
    ld _vx_e(ix), #0
    ld _vy_e(ix), #0
	ret

no_col_der::
	ld _vx_e(ix), #1
    ld _vy_e(ix), #0
	ret

; ;;;Enemy vs Player Collision
; col_enemy_player::
; 	ld hl, (_player_templ + _x_e)			; Cargar la posición X del jugador en HL
;     ;ld bc, (_player_templ + _w_e)			; Cargar el ancho de la entidad jugador en BC (asumiendo que también está definido)
;     ;add hl, bc							 	; Calcular la posición X + ancho para el jugador

; 	ld iy, (_lava_templ + _x_e)				; Cargar la posición X del enemigo en DE
;     ;ld de, (_lava_templ + _w_e)			; Cargar el ancho del enemigo en A
;     ;add iy, de								; Calcular la posición X + ancho para el enemigo
; 	ld a, (iy)

; 	cp a, (hl) 								; Compara la posición X + ancho del jugador con la del enemigo
;     jr c, _no_collision_x

; 	; ld _vx_e(ix), #0
;     ; ld _vy_e(ix), #0

; 	; ret

; 	_no_collision_x:
; 	; ld _vx_e(ix), #0
;     ; ld _vy_e(ix), #0

; 	ret

;;;Enemy vs Player Collision
;;IX Entity 1
;;IY Entity 2
; col_enemy_player::
;     ld a, _x_e(ix)      
;     add _w_e(ix)
;     sub _x_e(iy)
;     ;jr c, no_collision
;     jr si_collision

;     ld a, _x_e(iy)
;     add _w_e(iy)
;     sub _x_e(ix)
;     ;jr c, no_collision
;     jr si_collision

;     ret

sys_collision_enemy_weapon::
    ;;COLISION IZQUIERDA
    ld a, _x_e(ix)      
    add _w_e(ix)
    sub _x_e(iy)

    jr nc, _posible_col_izquierda ;; POSIBLE COLISION POR LA IZQUIERDA

    ld a, _x_e(iy)
    add _w_e(iy)
    sub _x_e(ix)
    jr nc, _posible_col_derecha  ;; POSIBLE COLISION POR LA DERECHA

ret

_posible_col_izquierda:
    ld a, _x_e(iy)
    add _w_e(iy)
    sub _x_e(ix)
    jr nc, _si_collision
ret


_posible_col_derecha:
    ld a, _x_e(ix)
    add _w_e(ix)
    sub _x_e(iy)
    jr nc, _si_collision
ret

_si_collision:
    call sys_score_add_kill
    call man_entities_set4destruction

ret


sys_collision_player::
    ;;COLISION IZQUIERDA
    ld a, _x_e(ix)      
    add _w_e(ix)
    sub _x_e(iy)

    jr nc, _posible_col_iz ;; POSIBLE COLISION POR LA IZQUIERDA

    ;;COLISION DERECHA
    ld a, _x_e(iy)
    add _w_e(iy)
    sub _x_e(ix)
    jr nc, _posible_col_de  ;; POSIBLE COLISION POR LA DERECHA
ret

_posible_col_iz:
    ld a, _x_e(iy)
    add _w_e(iy)
    sub _x_e(ix)
    jr nc, _colision_en_x
ret


_posible_col_de:
    ld a, _x_e(ix)
    add _w_e(ix)
    sub _x_e(iy)
    jr nc, _colision_en_x
ret

_colision_en_x:
    call sys_collision_with_player_y
ret


sys_collision_with_player_y::
    ld a, _y_e(ix)
    add _h_e(ix)
    sub _y_e(iy)
    jr nc, _comprobar_col_up ;; POSIBLE COLISION POR LA IZQUIERDA

    ld a, _y_e(iy)
    add _h_e(iy)
    sub _y_e(ix)
    jr nc, _comprobar_col_dw  ;; POSIBLE COLISION POR LA DERECHA
ret

_comprobar_col_up:
    ld a, _y_e(iy)
    add _h_e(iy)
    sub _y_e(ix)
    jr nc, _si_collisi
ret


_comprobar_col_dw:
    ld a, _y_e(ix)
    add _h_e(ix)
    sub _y_e(iy)
    jr nc, _si_collisi
ret

_si_collisi:
    ld _vx_e(ix), #0
    call man_entities_update_health

    ld a, _type_e(ix)
    or a
    ret z
    and #e_type_projectile
    jr z, salt
    
    ;;CODIGO PARA EL PROYECTIL
    call man_entities_set4destruction

    ld a, (piedras)
    inc a
    ld (piedras), a

    

    salt:
    ;;CODIGO PARA EL PROYECTIL
    call man_entities_set_invencible

ret


sys_collision_update_player_one_entity::
   ld iy, (player_adress)

   call sys_collision_player
ret
;;

sys_collision_update_weapon_one_entity::
    ld iy, (weapon_adress)
    
    call sys_collision_enemy_weapon
ret
;;

sys_collision_player_update::
    ld a, (player_invencible)
    or a
    ret nz

    ld  hl, #sys_collision_update_player_one_entity
    ld   b, #e_type_enemy 
    call man_entities_forall_matching
ret
;;

sys_collision_weapon_update::
    ld a, (arma)
    or a
    jr z, noexiste

    ld  hl, #sys_collision_update_weapon_one_entity
    ld   b, #e_type_killable
    call man_entities_forall_matching

    noexiste:
ret
;;