.module score
.include "man/entities_public.s"

;;
;; TIMER. This is where the values for the timer is stored
;; Four bytes, 0-9 values for each
;;
score::
.db #0, #0, #0, #0

;;
;; TIME INIT function. This sets the timer to 0
;; DESTROYED REGISTERS: [IX]
;;
sys_score_init::
    ld  ix, #score
    ld   0(ix), #0
    ld   1(ix), #0
    ld   2(ix), #0
    ld   3(ix), #0

    ret
;;

;;
;; SCORE ADD KILL function. This updates the current score value, adding the remaining timer values
;; INPUTS
;; - IX: Adress of the killed entity
;; DESTROYED REGISTERS: [A, B, IX, IY]
;;
sys_score_add_kill::
    ld  iy, #score
    ld   a, 3(iy)
    ld   b, #0
    add _kill_score_e(ix)
    
    _score_add_kill_3:
        ;; Check if the digit value is over 9
        cp #10
        jr c, _score_add_kill_3_value_not_over_9


        ;; If the digit position over 9, substract 10, update value for previous digit and repeat check
        sub     #10
        inc     b
        jr     _score_add_kill_3

    _score_add_kill_3_value_not_over_9:
        ld   3(iy), a       ;; Set the digit value and move on the next one
        ld   a, 2(iy)
        add  a, b           ;; Add the carry to the current digit
        ld   b, #0
        
        _score_add_kill_2:
            ;; Check if the digit value is over 9
            cp #10
            jr c, _score_add_kill_2_value_not_over_9


            ;; If the digit position over 9, substract 10, update value for previous digit and repeat check
            sub     #10
            inc     b
            jr     _score_add_kill_2

    _score_add_kill_2_value_not_over_9:
        ld   2(iy), a       ;; Set the digit value and move on the next one
        ld   a, 1(iy)
        add  a, b           ;; Add the carry to the current digit
        ld   b, #0
        
        _score_add_kill_1:
            ;; Check if the digit value is over 9
            cp #10
            jr c, _score_add_kill_1_value_not_over_9


            ;; If the digit position over 9, substract 10, update value for previous digit and repeat check
            sub     #10
            inc     b
            jr     _score_add_kill_1

    _score_add_kill_1_value_not_over_9:
        ld   1(iy), a       ;; Set the digit value and move on the next one
        ld   a, 0(iy)
        add  a, b           ;; Add the carry to the current digit
        ld   b, #0
        
        _score_add_kill_0:
            ;; Check if the digit value is over 9
            cp #10
            jr c, _score_add_kill_0_value_not_over_9


            ;; If the digit position over 9, substract 10, update value for previous digit and repeat check
            sub     #10
            inc     b
            jr     _score_add_kill_0

    _score_add_kill_0_value_not_over_9:
        ld   0(iy), a       ;; Set the digit value and end
        ret
;;

;;
;; SCORE ADD TIMER function. This updates the current score value, adding the remaining timer values
;; DESTROYED REGISTERS: [A, IX, IY]
;;
sys_score_add_timer::
    ld  ix, #timer
    ld  iy, #score
    ld   a, 3(iy)
    ld   b, #0
    add  a, 3(ix)       ;; Add the value of the current digit from the timer
    
    _score_add_timer_3:
        ;; Check if the digit value is over 9
        cp #10
        jr c, _score_add_timer_3_value_not_over_9


        ;; If the digit position over 9, substract 10, update value for previous digit and repeat check
        sub     #10
        inc     b
        jr     _score_add_timer_3

    _score_add_timer_3_value_not_over_9:
        ld   3(iy), a       ;; Set the digit value and move on the next one
        ld   a, 2(iy)
        add  a, b           ;; Add the carry to the current digit
        add  a, 2(ix)       ;; Add the value of the current digit from the timer
        ld   b, #0
        
        _score_add_timer_2:
            ;; Check if the digit value is over 9
            cp #10
            jr c, _score_add_timer_2_value_not_over_9


            ;; If the digit position over 9, substract 10, update value for previous digit and repeat check
            sub     #10
            inc     b
            jr     _score_add_timer_2

    _score_add_timer_2_value_not_over_9:
        ld   2(iy), a       ;; Set the digit value and move on the next one
        ld   a, 1(iy)
        add  a, b           ;; Add the carry to the current digit
        add  a, 1(ix)       ;; Add the value of the current digit from the timer
        ld   b, #0
        
        _score_add_timer_1:
            ;; Check if the digit value is over 9
            cp #10
            jr c, _score_add_timer_1_value_not_over_9


            ;; If the digit position over 9, substract 10, update value for previous digit and repeat check
            sub     #10
            inc     b
            jr     _score_add_timer_1

    _score_add_timer_1_value_not_over_9:
        ld   1(iy), a       ;; Set the digit value and move on the next one
        ld   a, 0(iy)
        add  a, b           ;; Add the carry to the current digit
        add  a, 0(ix)       ;; Add the value of the current digit from the timer
        ld   b, #0
        
        _score_add_timer_0:
            ;; Check if the digit value is over 9
            cp #10
            jr c, _score_add_timer_0_value_not_over_9


            ;; If the digit position over 9, substract 10, update value for previous digit and repeat check
            sub     #10
            inc     b
            jr     _score_add_timer_0

    _score_add_timer_0_value_not_over_9:
        ld   0(iy), a       ;; Set the digit value and end
        ret

    ret
;;